--MageGate--
-- Written by: Endar_Ren
-- 
--  
--  
--  
--
--

local frame = CreateFrame("Frame", nil, UIParent);



channeling =false;


function GateGroup ()

	if (UnitInBattleground("player") ~=nil) then
		return "BATTLEGROUND"
	end
	if (UnitInRaid("player") ~= nil) then
			return "RAID"
	end
	local inInstat, instantype = IsInInstance();
	if (instantype == "party") then

		return "PARTY"
	end

	return "SAY"
end

function GateEvent (self, event, unitID,spell,...)

	if (event == "ADDON_LOADED") then
		if (unitID =="Gate") then
			print ("Mage Gate loaded.  Version 1.0.");
		end
	end
	if (channeling == false) then
		if (event == "UNIT_SPELLCAST_START") then


			local beg, last = string.find(spell,"Portal: ");
			if (beg~=nil) then
				
				local chann = GateGroup();
				channeling = true;
				SendChatMessage("Dialing ".. string.sub(spell,last+1) ..".", chann);

				
			end

		end

	
	elseif (channeling == true) then

		if (event == "UNIT_SPELLCAST_SUCCEEDED") then

	
			local beg, last = string.find(spell,"Portal: ");
			if (beg~=nil) then
				local chann = GateGroup();
				channeling = false;
				SendChatMessage("Chevron 7 locked!", chann);

			end

	
		elseif (event == "UNIT_SPELLCAST_FAILED_QUIET") then


		
			local beg, last = string.find(spell,"Portal: ");
			if (beg~=nil) then
				local chann = GateGroup();
				channeling = false;
				SendChatMessage("Dailing sequence aborted!", chann);

			end
		

	
		elseif (event == "UNIT_SPELLCAST_INTERRUPTED") then


			local beg, last = string.find(spell,"Portal: ");
			if (beg~=nil) then
				local chann = GateGroup();
				channeling = false;
				SendChatMessage("Dailing sequence aborted!", chann);

			end
		

		end
	end
end



frame:SetScript("OnEvent", GateEvent)
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("UNIT_SPELLCAST_START")
frame:RegisterEvent("UNIT_SPELLCAST_STOP")
frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
frame:RegisterEvent("UNIT_SPELLCAST_FAILED_QUIET")
frame:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED") 